<template>
  <div
    v-if="Boolean(data)"
    class="ob-order-event"
    :class="{
      '--clickable': Boolean(data.uuid)
    }"
  >
    <div class="ob-order-event__datetime">
      {{ data.createdAt | date('HH:mm') }}<br>
      {{ data.createdAt | date('DD.MM.YYYY') }}
    </div>
    <div class="ob-order-event__title">
      <div class="title">{{ data.title }}</div>
      <template v-if="data.reasonRequired && !data.reasonTitle">
        <div class="description --danger">
          <i class="icon alert" />
          <span>Укажите причину</span>
        </div>
      </template>
      <template v-else>
        <ObShowMore
            v-if="Boolean(data.description)"
            :height="32"
            :is-compact="true"
            @click.native.stop
        >
          <div class="description">{{ data.description }}</div>
        </ObShowMore>
      </template>
    </div>
    <div
      class="ob-order-event__files"
    >
      <FilesDropdown
        :file-uuids="data.fileUuids"
      />
    </div>
    <div class="ob-order-event__source">
      <template v-if="participant">
        <div class="creator-info">
          <div
            class="creator-info__participant"
            :title="participant"
          >
            {{ participant }}
          </div>
          <div
            class="creator-info__user"
            :title="user"
          >
            {{ user }}
          </div>
        </div>
        <i
          v-if="uesrIcon"
          class="icon"
          :class="uesrIcon"
        />
      </template>
      <template v-else>
        {{ data.creatorType === 'TRACKING' ? 'Трекинг' : 'Системное' }}
      </template>
    </div>
  </div>
</template>

<script>
import FilesDropdown from '@/components/Order/filesDropdown'
import ObShowMore from 'common-components/src/obComponents/obShowMore'

export default {
  name: 'OrderEvent',
  props: {
    data: {
      type: Object,
      default: null
    }
  },
  components: {
    ObShowMore,
    FilesDropdown
  },
  computed: {
    uesrIcon () {
      const iconMap = {
        CLIENT: 'role-client',
        CLICAR: 'role-domain-owner',
        CARRIER: 'carrier',
        EXPEDITOR: 'role-domain-owner'
      }

      return iconMap[this.data.creatorType] || null
    },
    participant () {
      return this.data.creatorTitle || null
    },
    user () {
      return this.data.authorTitle || null
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "../../../../../../node_modules/common-components/src/static/css/mixins";

  .ob-order-event {
    display: flex;
    margin-bottom: 2px;
    padding: 6px 20px;
    background-color: $light-lavender;
    &.--clickable {
      cursor: pointer;
      border: 1px solid $light-lavender;
      &:hover {
        border-color: $cornflower-craiola;
      }
    }
    &__datetime {
      width: 70px;
      flex-shrink: 0;
      align-self: center;
      @include font-mixin(11px, 18px, 400, $color-grey-span, 0.4px);
      text-align: left;
    }
    &__title {
      display: flex;
      flex-direction: column;
      justify-content: center;
      margin-left: 50px;
      margin-right: 50px;
      flex-grow: 2;
      .title {
        @include font-mixin(12px, 16px, 400, $color-text-base, 0.2px);
      }
      .description {
        display: flex;
        align-items: center;
        @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px);
        &.--danger {
          margin-top: 2px;
          .icon {
            font-weight: 900;
            margin-right: 8px;
            color: $color-error;
          }
        }
      }
      &::v-deep {
        .ob-show-more-container {
          margin-top: 2px;
          .toggle-button {
            padding: 0 3px!important;
            background-color: $light-lavender!important;
          }
        }
      }
    }
    &__files {
      display: flex;
      align-items: center;
      width: 30px;
      flex-shrink: 0;
      max-height: 48px;
      margin-right: 30px;
    }
    &__source {
      display: flex;
      align-items: center;
      width: 250px;
      max-height: 48px;
      flex-shrink: 0;
      justify-content: flex-end;
      text-align: right;
      @include font-mixin(12px, 14px, 400, $color-grey-span, 0.4px);
      .creator-info {
        min-width: 0;
        flex-grow: 2;
        &__participant {
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px);
        }
        &__user {
          margin-top: 2px;
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          @include font-mixin(12px, 16px, 400, $color-grey-span, 0.2px);
        }
      }
      .icon {
        margin-left: 8px;
        color: $color-blue-navy-blue;
        font-size: 16px;
      }
    }
  }
</style>
